import { ValueObject } from "@/core/common/domain";
import { Maybe, Result } from "@repo/rdx-utils";
import { z } from "zod";

interface IInvoiceItemDescriptionProps {
  value: string;
}

export class InvoiceItemDescription extends ValueObject<IInvoiceItemDescriptionProps> {
  private static readonly MAX_LENGTH = 255;

  protected static validate(value: string) {
    const schema = z
      .string()
      .trim()
      .max(InvoiceItemDescription.MAX_LENGTH, {
        message: `Description must be at most ${InvoiceItemDescription.MAX_LENGTH} characters long`,
      });
    return schema.safeParse(value);
  }

  static create(value: string) {
    const valueIsValid = InvoiceItemDescription.validate(value);

    if (!valueIsValid.success) {
      return Result.fail(new Error(valueIsValid.error.errors[0].message));
    }
    return Result.ok(new InvoiceItemDescription({ value }));
  }

  static createNullable(value?: string): Result<Maybe<InvoiceItemDescription>, Error> {
    if (!value || value.trim() === "") {
      return Result.ok(Maybe.none<InvoiceItemDescription>());
    }

    return InvoiceItemDescription.create(value).map((value) => Maybe.some(value));
  }

  getValue(): string {
    return this.props.value;
  }

  toString(): string {
    return this.getValue();
  }

  toPrimitive() {
    return this.getValue();
  }
}
